package org.processmining.traceclusteringfsm.models;

import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.in.XParser;
import org.deckfour.xes.in.XParserRegistry;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.out.XSerializer;
import org.deckfour.xes.out.XSerializerRegistry;
import org.deckfour.xes.out.XesXmlGZIPSerializer;

import com.google.common.collect.BiMap;

import gnu.trove.map.hash.THashMap;
import pm.io.UtilIO;

public class FreqSeqPatterns {

	Map<Integer, Integer> mapPatternLenght2FreqMap = new THashMap<>();
	Map<Integer, Integer> mapPatternSet2FreqMap = new THashMap<>();
	Map<Integer, Integer> mapAct2NumPatterns = new THashMap<Integer, Integer>();
	
	List<List<Integer>> patterns = new ArrayList<List<Integer>>();
	
	
	
	

	public Map<Integer, Integer> getMapPatternLenght2FreqMap() {
		return mapPatternLenght2FreqMap;
	}

	public void setMapPatternLenght2FreqMap(Map<Integer, Integer> mapPatternLenght2FreqMap) {
		this.mapPatternLenght2FreqMap = mapPatternLenght2FreqMap;
	}

	public Map<Integer, Integer> getMapPatternSet2FreqMap() {
		return mapPatternSet2FreqMap;
	}

	public void setMapPatternSet2FreqMap(Map<Integer, Integer> mapPatternSet2FreqMap) {
		this.mapPatternSet2FreqMap = mapPatternSet2FreqMap;
	}

	public Map<Integer, Integer> getMapAct2NumPatterns() {
		return mapAct2NumPatterns;
	}

	public void setMapAct2NumPatterns(Map<Integer, Integer> mapAct2NumPatterns) {
		this.mapAct2NumPatterns = mapAct2NumPatterns;
	}

	public void addPattern(List<Integer> pattern) {
		// TODO Auto-generated method stub
		patterns.add(pattern);
	}
	
	public List<List<Integer>> getPatterns() {
		return patterns;
	}
	
	public int getMaxSize() {
		if(patterns.isEmpty()) {
			return 0;
		}
		return patterns.get(patterns.size() - 1).size();
	}
	
	public Set<Integer> getLabelSet(){
		return mapAct2NumPatterns.keySet();
	}
	
	public void printPatterns(BiMap<String, Integer> bimapAct2Int, String file) {
		PrintStream writerPatternLog = UtilIO.createWriter(file);
		int caseId = 0;
		int maxLength = 0;
		for (List<Integer> pattern : getPatterns()) {
			maxLength = pattern.size() > maxLength ? pattern.size() : maxLength;
		}

		for (List<Integer> pattern : getPatterns()) {
			if (pattern.size() >= maxLength - 1) {
				for (Integer a : pattern) {
					writerPatternLog.println(caseId + ";" + bimapAct2Int.inverse().get(a));
				}
				caseId++;
			}
		}
	}

	public void printPatternsXES(BiMap<String, Integer> bimapAct2Int, String file) {
		PrintStream writerPatternLog = UtilIO.createWriter(file);
		XFactory factory = XFactoryRegistry.instance().currentDefault();
		int caseId = 0;
//		int maxLength = getMaxSize();
//		for (List<Integer> pattern : getPatterns()) {
//			maxLength = pattern.size() > maxLength ? pattern.size() : maxLength;
//		}

		XLog log = factory.createLog();
		for (List<Integer> pattern : getPatterns()) {
//			if (pattern.size() >= maxLength - 1) {
				
				XTrace t = factory.createTrace();
				XConceptExtension.instance().assignName(t, String.valueOf(caseId));
				for (Integer a : pattern) {
					XEvent e = factory.createEvent();
					XConceptExtension.instance().assignName(e, String.valueOf(bimapAct2Int.inverse().get(a)));
					e.getAttributes().put("code", factory.createAttributeLiteral("code", String.valueOf(a), null));
					t.add(e);
				}
				log.add(t);
				caseId++;
//			}
		}
//		XParser parser = XParserRegistry.instance().currentDefault();
		XSerializer serializer = new XesXmlGZIPSerializer();
		try {
			serializer.serialize(log, writerPatternLog);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//		return log;
	}
}
